
/**
 * Hlavni trida, ktera vytvori dva zasobniky (+1 docasny), jeden Uzel (3,3,1) a stara se o samotne prohledavani
 * 
 * @author Martin ehnek
 * @version 1.0 4.10.2006
 */

import java.util.Stack;
public class Hlavni
{	
	public static void main(String[] args){
	   Stack<Uzel> zasobnikUzlu = new Stack<Uzel>();  
	   Stack<Uzel> zasobnikSynu = new Stack<Uzel>();
	   Stack<Uzel> zasobnikTemp;
	   Uzel aktualniUzel = new Uzel((byte)3,(byte)3,true,null); 
	   Uzel syn;
 	   
	   //dokud nenajdeme uzel, ktery ma vsechny na druhe strane
	   while ( !( (aktualniUzel.getMisionari() == 0) && (aktualniUzel.getKanibalove() == 0) && (aktualniUzel.getLod() == false) ) ) //stav (0,0,0)
	      {aktualniUzel.generujSyny(); 
	       for (byte i = 0; i < 5; i++) //do zasobnikSynu pridat syny akt. uzlu. 
	          {
	              if ( (syn = aktualniUzel.getSyn(i)) != null)
	                zasobnikSynu.push(syn);
	           }
	       if (zasobnikUzlu.empty())   //Uz neni zadny uzel aktualni vrstvy
	        {   
	            zasobnikTemp = zasobnikUzlu; //prehodit syny a uzly
	            zasobnikUzlu = zasobnikSynu;
	            zasobnikSynu = zasobnikTemp;
	         }
	        
	       aktualniUzel = zasobnikUzlu.pop();
	      }
	   
	   
	   //ulozeni posloupnosti predku od stavu (0,0,0) az po koren do zasobniku   
	   Stack<Uzel> zasobnikPredku = new Stack<Uzel>();
	   while( aktualniUzel !=  null)
	     { zasobnikPredku.push(aktualniUzel);
	       aktualniUzel = aktualniUzel.getPredek(); 
	      }
	   
	   //vypsat predky az po koren.
	   System.out.println("Posloupnost stavu az po akceptujici stav:");
	   while(!zasobnikPredku.empty())
	    {
	        System.out.println(zasobnikPredku.pop().toString());
	    }
	    
	}

}
